﻿using System;
using System.Diagnostics;
using System.Windows.Forms;
using Hau.Sample.Properties;

namespace Hau.Sample
{
    public partial class NomAutoUpdater : Form
    {
        public NomAutoUpdater()
        {
            InitializeComponent();
        }

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);

            // AutoUpdater의 속성을 설정 파일에서 읽는 예
//            autoUpdater.RootUri = Settings.Default.RootUri;

            autoUpdater.Run();
        }

        private void autoUpdater_FileTransfered(object sender, AutoUpdater.FileTransferedEventArgs e)
        {
            lsbFiles.Items.Add(e.RemoteFile.LocalPath);
            lsbFiles.SelectedIndex = lsbFiles.Items.Count - 1;
        }

        private void autoUpdater_FileTransfering(object sender, AutoUpdater.FileTransferingEventArgs e)
        {
            lblFile.Text = string.Format("{0} ({1:N0} / {2:N0}) ", e.RemoteFile.LocalPath, e.TransferingInfo.TransferedFileCount + 1, e.TransferingInfo.TotalFileCount);
        }

        private void autoUpdater_UpdatableListFound(object sender, AutoUpdater.UpdatableListFoundEventArgs e)
        {
            lblUpdatableList.Text = string.Format("업데이트할 파일이 {0}개 있습니다.", e.RemoteFiles.Count);
        }

        private void autoUpdater_UpdateProgressChanged(object sender, AutoUpdater.UpdateProgressChangedEventArgs e)
        {
            int percent = e.TransferingInfo.LengthPercent;
            prbProgress.Value = percent;
            lblLength.Text = string.Format("{0:N0} / {1:N0} ({2}%)", e.TransferingInfo.TotalTransferedLength, e.TransferingInfo.TotalLength, percent);
        }

        private void autoUpdater_UpdateCompleted(object sender, AutoUpdater.UpdateCompletedEventArgs e)
        {
            Process.Start(e.LocalRoot + "Nom.exe");
            Application.Exit();
        }
    }
}