using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Net;
using Hau;

namespace Hau
{
    /// <summary>
    /// HTTP  ڵ Ʈ ϴ ۳Ʈ
    /// </summary>
    [DefaultEvent("UpdateCompleted")]
    [Description("HTTP  ڵ Ʈ ϴ ۳Ʈ")]
    public partial class AutoUpdater : Component
    {
        public AutoUpdater()
        {
            InitializeComponent();
        }

        public AutoUpdater(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
        }

        /// <summary>
        ///  
        /// </summary>
        private TransferingInfo _transferingInfo;

        /// <summary>
        /// WebClient
        /// </summary>
        private WebClient _webClient;

        /// <summary>
        /// Ʈ URI. ) http://www.dolsan.org/nullnull/Nom
        /// </summary>
        [Description("Ʈ URI. ) http://www.dolsan.org/nullnull/Nom")]
        public string RootUri { get; set; }

        /// <summary>
        /// Ʈ   ̸. ) UpdatingList.xml
        /// </summary>
        [Description("Ʈ   ̸. ) UpdatingList.xml")]
        public string UpdateListFileName { get; set; }

        private string _localRoot;

        /// <summary>
        /// ٿε  Ʈ . ) c:\program files\NoM
        /// </summary>
        [Description("ٿε  Ʈ ")]
        public string LocalRoot
        {
            get { return _localRoot; }
            set
            {
                _localRoot = value;
                if (_localRoot.EndsWith("\\") == false)
                    _localRoot += "\\";
            }
        }

        /// <summary>
        /// Ʈ ؾ      Ʈ Ѵ.
        /// </summary>
        public void Run()
        {
            var updatableFiles = GetUpdatableFiles();
            
            OnUpdatableListFound(updatableFiles);

            LinkedList<RemoteFile> remoteFiles = new LinkedList<RemoteFile>(updatableFiles);

            // TransferingInfo غѴ.
            _transferingInfo = new TransferingInfo();
            _transferingInfo.TotalFileCount = remoteFiles.Count;
            foreach (var remoteFile in remoteFiles)
                _transferingInfo.TotalLength += remoteFile.ContentLength;

            if (remoteFiles.Count == 0)
            {
                OnUpdateCompleted(_transferingInfo, LocalRoot);
                return;
            }

            // WebClient غѴ.
            _webClient = new WebClient();
            _webClient.DownloadProgressChanged += WebClient_DownloadProgressChanged;
            _webClient.DownloadFileCompleted += WebClient_DownloadFileCompleted;

            // ù°  ٿε带 Ѵ.
            var node = remoteFiles.First;
            DownloadFile(node);
        }

        /// <summary>
        /// Ʈ ؾ    ´.
        /// </summary>
        /// <returns></returns>
        private List<RemoteFile> GetUpdatableFiles()
        {
            if (RootUri.EndsWith("/") == false)
                RootUri += "/";

            string listText = GetUpdatingText(RootUri + UpdateListFileName);

            UpdateListDataSet updateList = new UpdateListDataSet();
            StringReader reader = new StringReader(listText);
            updateList.ReadXml(reader);
            reader.Close();

            List<RemoteFile> remoteFiles = new List<RemoteFile>();

            foreach (UpdateListDataSet.FileRow file in updateList.File)
            {
                RemoteFile remoteFile = new RemoteFile();
                remoteFile.Uri = RootUri + file.Path.Replace('\\', '/');
                remoteFile.LocalPath = LocalRoot + file.Path;
                remoteFile.ContentLength = file.Length;
                remoteFile.LastModified = file.LastWriteTime;

                bool updatable = IsUpdatable(remoteFile);
                if (updatable)
                {
                    remoteFiles.Add(remoteFile);

                    OnUpdatableFileFound(remoteFile);
                }
            }

            return remoteFiles;
        }

        /// <summary>
        ///  Ʈ ؾ   ˻Ѵ.
        /// </summary>
        /// <param name="remoteFile"></param>
        /// <returns></returns>
        private bool IsUpdatable(RemoteFile remoteFile)
        {
            // ÿ  ̶ ٿεѴ.
            if (File.Exists(remoteFile.LocalPath) == false)
                return true;

            //  ¥ ٸٸ ٿεѴ.
            if (File.GetLastWriteTime(remoteFile.LocalPath) != remoteFile.LastModified)
                return true;

            // ÿ ϰ,  ¥ ٸ ٿε ʴ´.
            return false;
        }

        /// <summary>
        /// Ʈ    д´.
        /// </summary>
        /// <param name="listFileUri">Ʈ   URI</param>
        /// <returns>Ʈ </returns>
        private string GetUpdatingText(string listFileUri)
        {
            WebClient webClient = new WebClient();

            Stream stream = webClient.OpenRead(listFileUri);
            StreamReader reader = new StreamReader(stream);

            string text = reader.ReadToEnd();

            stream.Close();

            return text;
        }

        /// <summary>
        ///  ٿε Ѵ.
        /// </summary>
        /// <param name="node">RemoteFile ü  ִ  Ʈ </param>
        private void DownloadFile(LinkedListNode<RemoteFile> node)
        {
            OnFileTransfering(_transferingInfo, node.Value);

            // 丮   丮 .
            string directory = Path.GetDirectoryName(node.Value.LocalPath);
            if (directory.Length != 0 && Directory.Exists(directory) == false)
                Directory.CreateDirectory(directory);

            lock (_transferingInfo)
            {
                _transferingInfo.CurrentFilePath = node.Value.LocalPath;
            }

            _webClient.DownloadFileAsync(new Uri(node.Value.Uri), node.Value.LocalPath, node);
        }

        private void WebClient_DownloadFileCompleted(object sender, AsyncCompletedEventArgs e)
        {
            LinkedListNode<RemoteFile> node = (LinkedListNode<RemoteFile>)e.UserState;

            //  ¥   ¥ Ѵ.
            File.SetLastWriteTime(node.Value.LocalPath, node.Value.LastModified);

            lock (_transferingInfo)
            {
                _transferingInfo.TransferedFileCount++;
                _transferingInfo.TransferedLength += _transferingInfo.TransferingLength;
                _transferingInfo.TransferingLength = 0;
            }

            OnFileTransfered(_transferingInfo, node.Value);

            LinkedListNode<RemoteFile> nextNode = node.Next;
            if (nextNode != null)
            {
                DownloadFile(nextNode);
            }
            else
            {
                OnUpdateCompleted(_transferingInfo, LocalRoot);
            }
        }

        private void WebClient_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            lock (_transferingInfo)
            {
                _transferingInfo.TransferingLength = e.BytesReceived;
            }

            OnUpdateProgressChanged(_transferingInfo);
        }

        #region events

        #region UpdateCompleted event things for C# 3.0
        /// <summary>
        /// Ʈ .
        /// </summary>
        [Description("Ʈ .")]
        public event EventHandler<UpdateCompletedEventArgs> UpdateCompleted;

        protected virtual void OnUpdateCompleted(UpdateCompletedEventArgs e)
        {
            if (UpdateCompleted != null)
                UpdateCompleted(this, e);
        }

        protected virtual void OnUpdateCompleted(TransferingInfo transferingInfo, string localRoot)
        {
            if (UpdateCompleted != null)
                UpdateCompleted(this, new UpdateCompletedEventArgs(transferingInfo, localRoot));
        }

        public class UpdateCompletedEventArgs : EventArgs
        {

            public TransferingInfo TransferingInfo { get; set; }
            public string LocalRoot { get; set; }

            public UpdateCompletedEventArgs(TransferingInfo transferingInfo, string localRoot)
            {
                TransferingInfo = transferingInfo;
                LocalRoot = localRoot;
            }
        }
        #endregion

        #region UpdatableListFound event things for C# 3.0
        /// <summary>
        /// Ʈ    ߰ߵǾ.
        /// </summary>
        [Description("Ʈ    ߰ߵǾ.")]
        public event EventHandler<UpdatableListFoundEventArgs> UpdatableListFound;

        protected virtual void OnUpdatableListFound(UpdatableListFoundEventArgs e)
        {
            if (UpdatableListFound != null)
                UpdatableListFound(this, e);
        }

        protected virtual void OnUpdatableListFound(List<RemoteFile> remoteFiles)
        {
            if (UpdatableListFound != null)
                UpdatableListFound(this, new UpdatableListFoundEventArgs(remoteFiles));
        }

        public class UpdatableListFoundEventArgs : EventArgs
        {
            public List<RemoteFile> RemoteFiles { get; set; }

            public UpdatableListFoundEventArgs(List<RemoteFile> remoteFiles)
            {
                RemoteFiles = remoteFiles;
            }
        }
        #endregion

        #region UpdatableFileFound event things for C# 3.0
        /// <summary>
        /// Ʈ   ߰ߵǾ.
        /// </summary>
        [Description("Ʈ   ߰ߵǾ.")]
        public event EventHandler<UpdatableFileFoundEventArgs> UpdatableFileFound;

        protected virtual void OnUpdatableFileFound(UpdatableFileFoundEventArgs e)
        {
            if (UpdatableFileFound != null)
                UpdatableFileFound(this, e);
        }

        protected virtual void OnUpdatableFileFound(RemoteFile remoteFile)
        {
            if (UpdatableFileFound != null)
                UpdatableFileFound(this, new UpdatableFileFoundEventArgs(remoteFile));
        }

        public class UpdatableFileFoundEventArgs : EventArgs
        {
            public RemoteFile RemoteFile { get; set; }

            public UpdatableFileFoundEventArgs(RemoteFile remoteFile)
            {
                RemoteFile = remoteFile;
            }
        }
        #endregion

        #region FileTransfering event things for C# 3.0
        /// <summary>
        ///    ۵Ƿ .
        /// </summary>
        [Description("   ۵Ƿ .")]
        public event EventHandler<FileTransferingEventArgs> FileTransfering;

        protected virtual void OnFileTransfering(FileTransferingEventArgs e)
        {
            if (FileTransfering != null)
                FileTransfering(this, e);
        }

        protected virtual void OnFileTransfering(TransferingInfo ransferingInfo, RemoteFile remoteFile)
        {
            if (FileTransfering != null)
                FileTransfering(this, new FileTransferingEventArgs(ransferingInfo, remoteFile));
        }

        public class FileTransferingEventArgs : EventArgs
        {
            /// <summary>
            ///  
            /// </summary>
            public TransferingInfo TransferingInfo { get; set; }

            /// <summary>
            /// Ʈ   Ʈ
            /// </summary>
            public RemoteFile RemoteFile { get; set; }

            public FileTransferingEventArgs(TransferingInfo ransferingInfo, RemoteFile remoteFile)
            {
                TransferingInfo = ransferingInfo;
                RemoteFile = remoteFile;
            }
        }
        #endregion

        #region FileTransfered event things for C# 3.0
        /// <summary>
        ///    ϷǾ.
        /// </summary>
        [Description("   ϷǾ.")]
        public event EventHandler<FileTransferedEventArgs> FileTransfered;

        protected virtual void OnFileTransfered(FileTransferedEventArgs e)
        {
            if (FileTransfered != null)
                FileTransfered(this, e);
        }

        protected virtual void OnFileTransfered(TransferingInfo transferingInfo, RemoteFile remoteFile)
        {
            if (FileTransfered != null)
                FileTransfered(this, new FileTransferedEventArgs(transferingInfo, remoteFile));
        }

        public class FileTransferedEventArgs : EventArgs
        {
            /// <summary>
            ///  
            /// </summary>
            public TransferingInfo TransferingInfo { get; set; }

            /// <summary>
            /// Ʈ   Ʈ
            /// </summary>
            public RemoteFile RemoteFile { get; set; }

            public FileTransferedEventArgs(TransferingInfo transferingInfo, RemoteFile remoteFile)
            {
                TransferingInfo = transferingInfo;
                RemoteFile = remoteFile;
            }
        }
        #endregion

        #region UpdateProgressChanged event things for C# 3.0
        /// <summary>
        /// Ʈ  Ȳ Ǿ.
        /// </summary>
        [Description("Ʈ  Ȳ Ǿ.")]
        public event EventHandler<UpdateProgressChangedEventArgs> UpdateProgressChanged;

        protected virtual void OnUpdateProgressChanged(UpdateProgressChangedEventArgs e)
        {
            if (UpdateProgressChanged != null)
                UpdateProgressChanged(this, e);
        }

        protected virtual void OnUpdateProgressChanged(TransferingInfo transferingInfo)
        {
            if (UpdateProgressChanged != null)
                UpdateProgressChanged(this, new UpdateProgressChangedEventArgs(transferingInfo));
        }

        public class UpdateProgressChangedEventArgs : EventArgs
        {
            /// <summary>
            ///  
            /// </summary>
            public TransferingInfo TransferingInfo { get; set; }

            public UpdateProgressChangedEventArgs(TransferingInfo transferingInfo)
            {
                TransferingInfo = transferingInfo;
            }
        }
        #endregion
        #endregion
    }
}
